﻿using AbstractFoodOrdersContracts.BusinessLogicsContracts;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace FoodOrders
{
	public partial class FormMails : Form
	{
		private readonly ILogger _logger;
		private readonly IMessageInfoLogic _logic;
		public FormMails(ILogger<FormMails> logger, IMessageInfoLogic logic)
		{
			InitializeComponent();
			_logger = logger;
			_logic = logic;
		}

		private void FormMails_Load(object sender, EventArgs e)
		{
			try
			{
				dataGridView.FillAndConfigGrid(_logic.ReadList(null));
				_logger.LogInformation("Загрузка писем");
			}
			catch (Exception ex)
			{
				_logger.LogError(ex, "Ошибка загрузки писем");
				MessageBox.Show(ex.Message, "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}
	}
}
